<?php

namespace App\Http\Controllers;

use App\Models\BusinessContact;
use App\Models\Products;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class DashboardController extends Controller
{
    public function index(Request $request) {

        $queryCustomer = BusinessContact::where('category', 'customer');
        $customers['total'] = $queryCustomer->count();
        $customers['newest'] = $queryCustomer->whereDate('created_at', '>=', date_now()->subDays(15))->count();            

        $quertyProduct = Products::query();
        $products['total'] = $quertyProduct->count();
        $products['newest'] = $quertyProduct->whereDate('created_at', '>=', date_now()->subDays(15))->count();

        $sites = [
            'total' => 0,
            'newest' => 0
        ];

        return view('dashboard', [
            'customers' => $customers,
            'sites' => $sites,
            'products' => $products,
        ]);
    }
}
