<?php
namespace App;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Str;
use Intervention\Image\Facades\Image as Image;

class Images
{
    static $default_path = "";

    private $path_small;
    private $path_medium;
    private $path_thumb;
    private $path;
    public function __construct($folder)
    {
        $path = public_path($folder);
        if(!File::isDirectory($path)){
            File::makeDirectory($path, 0777, true, true);
            File::makeDirectory("$path/small", 0777, true, true);
            File::makeDirectory("$path/medium", 0777, true, true);
            File::makeDirectory("$path/thumbnails", 0777, true, true);
        }

        $this->path_small = "$folder/small";
        $this->path_medium = "$folder/medium";
        $this->path_thumb = "$folder/thumbnails";
        $this->path = "$folder";
    }

    public function image_upload($img, array $medium_size){
        $ext = $img->getClientOriginalExtension();
        $filename = rand(111,99999).time().'.'. $ext;
        $originalname = $img->getClientOriginalName();
        $img = Image::make($img);

        $rep = [];
        $rep['filename'] = $filename;
        $rep['original_name'] = $originalname;

        $rep[] = $img->save(public_path()."/".$this->path."/".$filename);

        $rep[] = $img->resize($medium_size['width'], null, function($constraint){
            $constraint->aspectRatio();
            $constraint->upsize();
        })->save(public_path()."/".$this->path_medium."/".$filename);

        $rep[] = $img->resize(170, null, function($constraint){
            $constraint->aspectRatio();
            $constraint->upsize();
        })->save(public_path()."/".$this->path_small."/".$filename);

        $rep[] = $img->resize(35, null, function($constraint){
            $constraint->aspectRatio();
            $constraint->upsize();
        })->save(public_path()."/".$this->path_thumb."/".$filename);

        $rep['mime'] = $rep[0]->mime;

        /*$image_id = DB::table("medias")->insertGetId([
            "type" => "images",
            "original_name" => $originalname,
            "filename" => $filename,
            "size" => $img->width() . " x" . $img->height() ."px - ". $this->Filesize($img->filesize(), 2),
            "mime" => $rep[0]->mime,
        ]);

        $rep['image_id'] = $image_id;*/

        return $rep;
    }

    private function Filesize(int $bytes, int $dec)
    {
        $size   = ['B', 'kB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
        $factor = floor((strlen($bytes) - 1) / 3);

        return sprintf("%.{$dec}f %s", ($bytes / (1024 ** $factor)), $size[$factor]);
    }

    public function move_file($file){
        $path = public_path($this->path);
        if(!File::isDirectory($path)){
            File::makeDirectory($path, 0777, true, true);
        }

        $extension = $file->getClientOriginalExtension();

        $originalname = Str::slug($file->getClientOriginalName()).".".$extension;
        $rep[] = $file->move($path, $originalname);
        $rep['filename'] = $originalname;

        return $rep;
    }
}
