<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class BusinessContact extends Model
{
    use HasFactory;

    protected $table = "business_contacts";
    protected $fillable = [
        "location_id",
        "category",
        "group_id",
        "group",
        "numero",
        "reference",        
        "company",
        "lastname",
        "firstname",       
        "email",        
        "phone",
        "address",
        "postcode",
        "city",        
        "slug",
        "memo",
        "status",
        "image",
        "status",
        "userid",
        "username",
        "update_by",
        "contact_info",
        "bank_info",
        "company_info",
        "credit"
    ];
    
    public function commandes(){
        return $this->hasMany(Commande::class, 'customer_id', 'id');
    }

    public function ventes(){
        return $this->hasMany(Vente::class, 'customer_id', 'id');
    }    

    public function retours(){
        return $this->hasMany(Retour::class, 'customer_id', 'id');
    }

    public function documents(){
        return $this->hasMany(BusinessContactDocument::class, 'customer_id', 'id');
    }
}
