<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB;
use Illuminate\Http\Request;

class Permission extends Model
{
    use HasFactory;
    public function permissions()
    {
        $alls = DB::table("permissions")->where("is_admin", 0)->get();
        $index = 0;
        foreach($alls as $p){
            $add = intval($p->action_add) === 1 ? "<i class='bi bi-check text-success'></i> Ajout" : "<i class='bi bi-x-circle text-danger'></i> Ajout";
            $upd = intval($p->action_edit) === 1 ? "<i class='bi bi-check text-success'></i> Modif" : "<i class='bi bi-x-circle text-danger'></i> Modif";
            $del = intval($p->action_delete) === 1 ? "<i class='bi bi-check text-success'></i> Suppr" : "<i class='bi bi-x-circle text-danger'></i> Suppr";
            $section = "";

            //$alls[$index]->checked =  $p->status == "active";
            $alls[$index]->action =  $add . " ". $upd . " " . $del . "<br>" . "<span class='font13'>$section</span>";
            $index++;
        }

        return $alls;
    }

    public function insertrecord(Request $request)
    {
        $data = [
            "title" => $request->title,

            'action_add' => isset($request->add_action) ? 1 : 0,
            'action_edit' => isset($request->update_action) ? 1 : 0,
            'action_delete' => isset($request->delete_action) ? 1 : 0,

            'status' => $request->status,
            'created_at' => date_now(),
            'updated_at' => date_now(),
        ];

        #dd($request->permissions);

        foreach($request->permissions as $key => $item){
            if(isset($item["child"])){
                foreach($item["child"] as $k => $child){
                    $data[$child["id"]] = $child["value"];
                }
            }else{
                $data[$item["id"]] = $item["value"];
            }
        }

        return DB::table('permissions')->insert($data);
    }

    public function updaterecord(Request $request)
    {
        $id = $request->id;

        $data = [
            "title" => $request->title,

            'action_add' => isset($request->add_action) ? 1 : 0,
            'action_edit' => isset($request->update_action) ? 1 : 0,
            'action_delete' => isset($request->delete_action) ? 1 : 0,

            'status' => $request->status,
            'updated_at' => date_now(),
        ];

        #dd($request->permissions);

        foreach($request->permissions as $key => $item){
            if(isset($item["child"])){
                foreach($item["child"] as $k => $child){
                    $data[$child["id"]] = $child["value"];
                }
            }else{
                $data[$item["id"]] = $item["value"];
            }
        }

        return DB::table('permissions')->where('id', $id)->update($data);
    }
}
