<?php

use App\Services\ActionService;
use App\Services\MenuLoader;
use Carbon\Carbon;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Session;
use modules\location\Models\Location;

    if(!function_exists('businessContact')){
        function businessContact() : array {
            return [
                "customer" => "Client",
                "supplier" => "Fournisseur"
            ];
        }
    }

    if (!function_exists('add_action')) {
        function add_action($hook, $callback)
        {            
            app(ActionService::class)->addAction($hook, $callback);
        }
    }
    
    if (!function_exists('do_action')) {
        function do_action($hook, $params = [])
        {
            app(ActionService::class)->doAction($hook, $params);
        }
    }
    
    if (!function_exists('get_menu_config')) {
        function get_menu_config($key)
        {
            return app(ActionService::class)->getMenuConfig($key);
        }
    }


    function user($user_id)
    {
        return DB::table("users")->where("id", $user_id)->first();
    }

    function category($category_id)
    {
        return DB::table("categories")->where("id", $category_id)->first();
    }

    function phone(string $phone){
        if((int)substr($phone, 0, 1) == 0){
            $phone = substr($phone, 1, strlen($phone));
        }else{
            $phone = $phone;
        }

        return $phone;
    }

    function auto_number($document, $num){
        $data = DB::table("numerotation")->where('description', $document)->first();
        #dd($data, $document);
        $format = $data->format;
        $date = Carbon::now();

        $n1 = explode('[#', $format);
        $n2 = explode('#]', $n1[1]);

        $n = substr($n2[0], 0, strlen($n2[0]) - strlen($num)) . $num;
        #dd($n, $data);
        $p1 = strpos($data->format, "[#") + 2;
        $p2 = strpos($data->format, "#]");
        $_n = substr($data->format, $p1, $p2 - $p1);

        $res1 = str_replace('[YYYY]', $date->format('Y'),
                    str_replace('[YY]', $date->format('y'),
                    str_replace('[MM]', $date->format('m'),
                    str_replace('[JJ]', $date->format('d'),
                    str_replace('[__]', "  ",
                    str_replace('[-]', "-",
                    str_replace('[_]', "_",
                    str_replace('[/]', "/",
                    str_replace('[°]', "°",
                    $format)))))))));

        $result = str_replace("[#$_n#]" , $n, $res1);
        #dd($result, $res1, $data->begin_num);
        return str_replace("[", "", str_replace("]", "", $result));
    }

    function convertToFloat($float) {
        return (float)str_replace(" ", "", $float);
    }

    function generateString($length)
    {
        $alpha = "012345689azertyuiopqsdfghjklmwxcvbnAZERTYUIOPQSDFGHJKLMWXCVBN";
        return substr(str_shuffle(str_repeat($alpha, $length)), 0, $length) ;
    }

    function pagination($table, $condition = null){
        if(Session::has("pagination") && Session::get("pagination") != "all"){
            $limit = Session::get('pagination');
            $pagination_status = true;
        }else if(Session::has("pagination") && Session::get("pagination") == "all"){
            $sql = "SELECT COUNT(id) as nb FROM $table";
            if(!is_null($condition)){
                $sql .= " WHERE $condition";
            }

            $raw = DB::select($sql);
            $limit = $raw[0]->nb;
            $pagination_status = true;
            session(['pagination' => "all"]);
        }else{
            $pagination_status = true;
            $limit = 15;
            session(['pagination' => $limit]);
        }

        return [
            "status" => $pagination_status,
            "page" => $limit
        ];
    }

    function number_to_letter($nombre, $U = null, $D = null){
        global $toLetter;

        $toLetter = [
            0 => "zéro",
            1 => "un",
            2 => "deux",
            3 => "trois",
            4 => "quatre",
            5 => "cinq",
            6 => "six",
            7 => "sept",
            8 => "huit",
            9 => "neuf",
            10 => "dix",
            11 => "onze",
            12 => "douze",
            13 => "treize",
            14 => "quatorze",
            15 => "quinze",
            16 => "seize",
            17 => "dix-sept",
            18 => "dix-huit",
            19 => "dix-neuf",
            20 => "vingt",
            30 => "trente",
            40 => "quarante",
            50 => "cinquante",
            60 => "soixante",
            70 => "soixante-dix",
            80 => "quatre-vingt",
            90 => "quatre-vingt-dix",
        ];

        $numberToLetter='';
        $nombre = strtr((string)$nombre, [" "=>""]);
        $nb = floatval($nombre);

        if(strlen($nombre) > 15) return "dépassement de capacité";
        if(!is_numeric($nombre)) return "Nombre non valide";
        if(ceil($nb) != $nb){
            $nb = explode('.',$nombre);
            return number_to_letter($nb[0]) . ($U ? " $U et " : " virgule ") . number_to_letter($nb[1]) . ($D ? " $D" : "");
        }

        $n = strlen($nombre);
        switch($n){
            case 1:
                $numberToLetter = $toLetter[$nb];
                break;
            case 2:
                if($nb > 19){
                    $quotient = floor($nb / 10);
                    $reste = $nb % 10;
                    if($nb < 71 || ($nb > 79 && $nb < 91)){
                        if($reste == 0) $numberToLetter = $toLetter[$quotient * 10];
                        if($reste == 1) $numberToLetter = $toLetter[$quotient * 10] . "-et-" . $toLetter[$reste];
                        if($reste > 1) $numberToLetter = $toLetter[$quotient * 10] . "-" . $toLetter[$reste];
                    }else $numberToLetter = $toLetter[($quotient - 1) * 10] . "-" . $toLetter[10 + $reste];
                }else $numberToLetter = $toLetter[$nb];
                break;

            case 3:
                $quotient = floor($nb / 100);
                $reste = $nb % 100;
                if($quotient == 1 && $reste == 0) $numberToLetter = "cent";
                if($quotient == 1 && $reste != 0) $numberToLetter = "cent" . " " . number_to_letter($reste);
                if($quotient > 1 && $reste == 0) $numberToLetter = $toLetter[$quotient] . " cents";
                if($quotient > 1 && $reste != 0) $numberToLetter = $toLetter[$quotient] . " cent " . number_to_letter($reste);
                break;
            case 4 :
            case 5 :
            case 6 :
                $quotient = floor($nb / 1000);
                $reste = $nb - $quotient * 1000;
                if($quotient == 1 && $reste == 0) $numberToLetter = "mille";
                if($quotient == 1 && $reste != 0) $numberToLetter = "mille" . " " . number_to_letter($reste);
                if($quotient > 1 && $reste == 0) $numberToLetter = number_to_letter($quotient) . " mille";
                if($quotient > 1 && $reste != 0) $numberToLetter = number_to_letter($quotient) . " mille " . number_to_letter($reste);
                break;
            case 7:
            case 8:
            case 9:
                $quotient = floor($nb / 1000000);
                $reste = $nb % 1000000;
                if($quotient == 1 && $reste == 0) $numberToLetter = "un million";
                if($quotient == 1 && $reste != 0) $numberToLetter = "un million" . " " . number_to_letter($reste);
                if($quotient > 1 && $reste == 0) $numberToLetter = number_to_letter($quotient) . " millions";
                if($quotient > 1 && $reste != 0) $numberToLetter = number_to_letter($quotient) . " millions " . number_to_letter($reste);
                break;
            case 10:
            case 11:
            case 12:
                $quotient = floor($nb / 1000000000);
                $reste = $nb - $quotient * 1000000000;
                if($quotient == 1 && $reste == 0) $numberToLetter = "un milliard";
                if($quotient == 1 && $reste != 0) $numberToLetter = "un milliard" . " " . number_to_letter($reste);
                if($quotient > 1 && $reste == 0) $numberToLetter = number_to_letter($quotient) . " milliards";
                if($quotient > 1 && $reste != 0) $numberToLetter = number_to_letter($quotient) . " milliards " . number_to_letter($reste);
                break;
            case 13:
            case 14:
            case 15:
                $quotient = floor($nb / 1000000000000);
                $reste = $nb - $quotient * 1000000000000;
                if($quotient == 1 && $reste == 0) $numberToLetter = "un billion";
                if($quotient == 1 && $reste != 0) $numberToLetter = "un billion" . " " . number_to_letter($reste);
                if($quotient > 1 && $reste == 0) $numberToLetter = number_to_letter($quotient) . " billions";
                if($quotient > 1 && $reste != 0) $numberToLetter = number_to_letter($quotient) . " billions " . number_to_letter($reste);
                break;
        }
        /*respect de l'accord de quatre-vingt*/
        if( substr($numberToLetter, strlen($numberToLetter)-12, 12) == "quatre-vingt") $numberToLetter .= "s";

        return $numberToLetter;
    }

    function date_now(){
        return Carbon::now()->timezone(env('APP_TIMEZONE'));
    }

    function message(){
        return [
            "success" => "Enregistrement effectué avec succés.",
            "update" => "Mis à jour effectué avec succés.",
        ];
    }

    function menus($type)
    {
        // Chargement dynamique des configurations de menu
        $menuConfig = MenuLoader::load();                

        if (isset(Route::getFacadeRoot()->current()->action['as'])) {
            $currentRoute = Route::currentRouteName();
            $routeAction = $currentRoute;            
            $active = [];
            
            if (!is_null($routeAction)) {
                $module = explode(".", $routeAction);

                #dd($menuConfig, $type, $module[1]);
                
                // Vérifier si le menu pour ce module existe
                if (isset($menuConfig[$module[1]])) {
                    $active = null;
                    
                    $module2 = "";
                    if (isset($menuConfig[$module[1]]['child'])) {
                        $module2 = $module[2] ?? '';
                        
                        if ($module[1] == 'crm') {
                            $module2 = request()->type ?? $module[2];
                        }

                        if($module[1] == 'sales'){
                            $module[1] = request()->category == 'supplier' ? 'purchases' : 'sales';
                            $module2 = request()->type;
                        }
                        
                        if (isset($menuConfig[$module[1]]['child'][$module2])) {
                            $menuConfig[$module[1]]['child'][$module2]['active'] = true;
                        }
                    }

                    if ($menuConfig[$module[1]]['name'] == $module[1]) {
                        $menuConfig[$module[1]]['active'] = true;
                        $active = $menuConfig[$module[1]];
                    }
                }
                
                return [
                    'data' => $menuConfig ?? [],
                    'active' => $active,
                    'parent' => $module[1] ?? null,
                    'module' => $module2 ?? null,
                ];
            }
        }
    }


    if(!function_exists('numerotation')){
        function numerotation(String $type)
        {
            return DB::table('numerotation')->where("description", $type)->first();
        }
    }    


    function numero(String $type)
    {
        $last = DB::table($type)->whereNotNull("reference")->orderByDesc("created_at")->limit(1)->first();
        
        $lastnum = !is_null($last) ? $last->num_index : 0;
        $index = $lastnum + 1;
        $num = auto_number($type, $index);

        return [
            "reference" => $num,
            "index" => $index
        ];
    }

    function countries(){
        $_countries = DB::table("countries")->get();
        $countries = $_countries->map(function($country){            
            return [
                "id" => $country->id,
                "name" => (json_decode($country->translation))->fra->common,
                'flag' => strtoupper($country->iso_2).".svg",
                'phone_code' => $country->phone_code,
            ];
        })->sortBy("name")->values()->toArray();
        
        return $countries;
    }
