<?php

namespace modules\catalogs\Http\Controllers;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use modules\catalogs\Models\Category;
use modules\catalogs\services\CategoryService;
use modules\catalogs\services\ProductService;
use modules\crm\Models\CustomerGroup;
use modules\crm\services\CrmService;

class catalogsController extends Controller
{

    protected $category;
    public function __construct(CategoryService $category)
    {   
        $this->category = $category;
    }

    protected $all = [
        [
            'id' => -1,
            'title' => 'Tous',
            'parent_id' => null,
            'backcolor' => "#ffffff",
            'color' => "#000000",
            "slug" => "all",
            'children' => []
        ],
        [
            'id' => 0,
            'title' => 'Favoris',                
            'parent_id' => null,
            'backcolor' => "#ffffff",
            'color' => "#000000",
            "slug" => "favorites",
            'children' => []
        ],
    ];
    
    public function loaddata(Request $request){
        $page = $request->input('pagesize');
        $filters = $request->only(['parent', 'category']);
        $category_id = null;
        if($request->has('parent')){
            $category_id = $request->parent;
        }else{
            if($request->has('category')){
                if(is_numeric($request->category)){
                    $category_id = $request->category;
                }else{
                    $category_id = Category::where('slug', $request->category)->first()->id;
                }                
            }
        }

        $categories = $this->category->categories($filters);
        $filter = [
            'location' => $request->location,
            'category' => $category_id
        ];
        #dd($filter);
        if($request->has("with")){
            $filter['with'] = $request->with;
            $filter['inventory-slug'] = $request->input('inventory-slug');
        }

        if($request->has("group")){
            $filter['group_id'] = $request->group;
        }
        
        if($request->has('keyword') && $request->has('criteria')){
            $filter['keyword'] = $request->input('keyword');
            $filter['criteria'] = $request->input('criteria');
        }
        #dd($filter);
        $page = is_null($page) ? 0 : $page;
        $products = ProductService::products($filter, $page);

        return response()->json([
            'status' => 'success',
            'categories' => [
                'data' => $categories['categories'],
                'child' => $categories['isChild'],
                'parent' => $categories['parent']
            ],
            'products' => $products
        ]);
    }
}