<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('business_contacts_transactions', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('business_contact_id')->nullable();
            $table->string('business_contact_name')->nullable();
            $table->enum('business_contact_type', ['customer','prospect','supplier','subcontractor','provider','reseller'])->nullable();
            $table->enum('transaction_type', ['in', 'out']);
            $table->text('description');
            $table->double('amount')->default(0);
            $table->double('balance_after_transaction')->default(0);
            $table->timestamps();
            $table->foreign('business_contact_id')->on('business_contacts')->references('id')->onDelete('cascade');
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('business_contacts_transactions');
    }
};
