<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    public function up(): void
    {
        Schema::create('business_contacts', function (Blueprint $table) {
            $table->id();
            $table->enum('category', ['customer', 'prospect', 'supplier', 'subcontractor', 'provider', 'customer']);
            $table->unsignedBigInteger('group_id')->nullable();
            $table->string('group')->nullable();
            $table->bigInteger('numero')->default(0);
            $table->string('reference')->nullable();
            $table->string('company')->nullable();
            $table->string('lastname')->nullable();
            $table->string('firstname')->nullable();
            $table->string('email')->nullable();
            $table->string('phone')->nullable();
            $table->string('slug')->nullable();
            $table->string('image')->nullable();
            $table->text('address')->nullable();
            $table->string('postcode')->nullable();
            $table->string('city')->nullable();
            $table->enum('status', ['inactive', 'active'])->nullable();
            $table->text('memo')->nullable();
            $table->unsignedBigInteger('userid')->nullable();
            $table->string('username')->nullable();
            $table->timestamps();
        });
    }

    public function down(): void
    {
        Schema::dropIfExists('business_contacts');
    }
};
