<?php

use Illuminate\Support\Facades\Route;
use modules\location\Http\Controllers\LocationController;

Route::prefix('locations/{type}')
    ->as('app.location.')
    ->middleware(['web', 'auth'])
    ->group(function(){
    Route::get('/', [LocationController::class, 'index'])->name('index');
    Route::get('/locations', [LocationController::class, 'locations'])->name('locations');  

    Route::prefix('/{site}/invoices')->as('locations.')->group(function(){
        Route::get('/', [LocationController::class, 'invoices'])->name('invoices');  
        Route::get('/{slug}/detail', [LocationController::class, 'invoice_detail'])->name('invoice.detail');  
        Route::get('/get/4520hqkj', [LocationController::class, 'getinvoice'])->name('invoices.get');

        Route::post('/payment', [LocationController::class, 'invoicePayment'])->name('invoice.payment');
    });

    Route::post('/save', [LocationController::class, 'save'])->name('save');
    
    Route::delete('destroy/{id}', [LocationController::class, 'destroy'])->name('destroy');
}); 