import numeral from 'numeral';

// Enregistrez le locale français
if (!numeral.locales.fr) {
    numeral.register('locale', 'fr', {
        delimiters: {
            thousands: ' ',
            decimal: ','
        },
        abbreviations: {
            thousand: 'k',
            million: 'm',
            billion: 'b',
            trillion: 't'
        },
        ordinal: function(number) {
            return number === 1 ? 'er' : 'ème';
        },
        currency: {
            symbol: '€'
        }
    });
}

// Définissez la locale actuelle sur "fr"
numeral.locale('fr');

// Exportez Numeral pour le rendre disponible globalement
export default numeral;
