<?php

namespace modules\crm\Models;

use App\Models\Site;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use modules\location\Models\Location;
use modules\sales\Models\AccountingDocument;

class BusinessContact extends Model
{
    use HasFactory;

    protected $table = "business_contacts";
    protected $fillable = [
        "location_id",
        "category",
        "group_id",
        "group",
        "numero",
        "reference",        
        "company",
        "lastname",
        "firstname",       
        "email",        
        "phone",
        "address",
        "postcode",
        "city",        
        "slug",
        "memo",
        "status",        
        "userid",
        "username",
        "update_by",
        'avatar',
        'contact_phone',
        'bank_info',
        'company_info',
        "credit"
    ];
    
    public function group(){
        return $this->belongsTo(CustomerGroup::class, 'group_id', 'id')->select('id', 'title', 'b2b', 'credit', 'rate_type', 'rate_value');
    }

    public function location(){
        return $this->belongsTo(Location::class, 'location_id', 'id')->select('id', 'title', 'type');
    }
    
    public function commandes(){
        return []; #$this->hasMany(Commande::class, 'customer_id', 'id');
    }

    public function ventes(){
        return []; #$this->hasMany(Vente::class, 'customer_id', 'id');
    }    

    public function retours(){
        return []; #$this->hasMany(Retour::class, 'customer_id', 'id');
    }

    public function documents(){
        return $this->hasMany(BusinessContactDocument::class, 'customer_id', 'id');
    }

    public function accounting_documents(){
        return $this->hasMany(AccountingDocument::class, 'customer_id', 'id');
    }
    
    public function transactions(){
        return $this->hasMany(BusinessContactTransaction::class, 'business_contact_id', 'id');
    }    
}
