<?php

namespace modules\location\Providers;

use App\Services\ModuleService;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Blade;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\ServiceProvider;
use modules\location\Models\Location;

class LocationServiceProvider extends ServiceProvider
{
    public function boot()
    {
        $this->loadMigrationsFrom(base_path('modules/location/database/migrations'));
        
        $this->loadRoutesFrom(base_path('modules/location/routes/web.php'));
        
        $this->loadViewsFrom(base_path('modules/location/resources/views'), 'location');    
        
        $this->mergeConfigFrom(base_path('modules/location/config/location.php'), 'location');
        $this->mergeConfigFrom(base_path('modules/location/config/menu.php'), 'location.menu');
    }
}
