<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('receipts_details', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('receipt_id');
            $table->unsignedBigInteger('product_id')->nullable();
            $table->unsignedBigInteger('parent_id')->nullable();
            $table->string('product')->nullable();
            $table->string('product_reference')->nullable();
            $table->string('product_image')->nullable();
            $table->double('quantity', 12, 2)->default(0);
            $table->double('parent_quantity', 12, 2)->default(0);
            $table->unsignedBigInteger('unite_id')->nullable();            
            $table->string('unite')->nullable();
            $table->double('price', 12, 2)->default(0);
            $table->double('total_ht', 12, 2)->default(0);
            $table->enum('discount_by', ['percent', 'amount'])->nullable();
            $table->double('discount_rate', 12, 2)->default(0);
            $table->double('discount_price', 12, 2)->default(0);
            $table->double('tva_rate', 12, 2)->default(0);
            $table->double('tva_price', 12, 2)->default(0);
            $table->double('delivery_price', 12, 2)->default(0);
            $table->double('total_ttc', 12, 2)->default(0);
            $table->string('token')->nullable();

            $table->foreign('receipt_id')->references('id')->on('receipts')->onDelete('cascade');
            $table->foreign('product_id')->references('id')->on('products')->onDelete('set null');
            $table->foreign('parent_id')->references('id')->on('products')->onDelete('set null');

            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('receipts_details');
    }
};
