import {
  script
} from "./chunk-3H5SAOFT.js";
import {
  BaseStyle
} from "./chunk-3SLAW24Q.js";
import {
  createBaseVNode,
  createCommentVNode,
  createElementBlock,
  init_vue_esm_bundler,
  mergeProps,
  openBlock,
  renderSlot
} from "./chunk-A2PEDHXA.js";

// node_modules/@primeuix/styles/card/index.mjs
var style = ({ dt: n }) => `
.p-card {
    background: ${n("card.background")};
    color: ${n("card.color")};
    box-shadow: ${n("card.shadow")};
    border-radius: ${n("card.border.radius")};
    display: flex;
    flex-direction: column;
}

.p-card-caption {
    display: flex;
    flex-direction: column;
    gap: ${n("card.caption.gap")};
}

.p-card-body {
    padding: ${n("card.body.padding")};
    display: flex;
    flex-direction: column;
    gap: ${n("card.body.gap")};
}

.p-card-title {
    font-size: ${n("card.title.font.size")};
    font-weight: ${n("card.title.font.weight")};
}

.p-card-subtitle {
    color: ${n("card.subtitle.color")};
}
`;

// node_modules/primevue/card/style/index.mjs
var classes = {
  root: "p-card p-component",
  header: "p-card-header",
  body: "p-card-body",
  caption: "p-card-caption",
  title: "p-card-title",
  subtitle: "p-card-subtitle",
  content: "p-card-content",
  footer: "p-card-footer"
};
var CardStyle = BaseStyle.extend({
  name: "card",
  style,
  classes
});

// node_modules/primevue/card/index.mjs
init_vue_esm_bundler();
var script$1 = {
  name: "BaseCard",
  "extends": script,
  style: CardStyle,
  provide: function provide() {
    return {
      $pcCard: this,
      $parentInstance: this
    };
  }
};
var script2 = {
  name: "Card",
  "extends": script$1,
  inheritAttrs: false
};
function render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createElementBlock("div", mergeProps({
    "class": _ctx.cx("root")
  }, _ctx.ptmi("root")), [_ctx.$slots.header ? (openBlock(), createElementBlock("div", mergeProps({
    key: 0,
    "class": _ctx.cx("header")
  }, _ctx.ptm("header")), [renderSlot(_ctx.$slots, "header")], 16)) : createCommentVNode("", true), createBaseVNode("div", mergeProps({
    "class": _ctx.cx("body")
  }, _ctx.ptm("body")), [_ctx.$slots.title || _ctx.$slots.subtitle ? (openBlock(), createElementBlock("div", mergeProps({
    key: 0,
    "class": _ctx.cx("caption")
  }, _ctx.ptm("caption")), [_ctx.$slots.title ? (openBlock(), createElementBlock("div", mergeProps({
    key: 0,
    "class": _ctx.cx("title")
  }, _ctx.ptm("title")), [renderSlot(_ctx.$slots, "title")], 16)) : createCommentVNode("", true), _ctx.$slots.subtitle ? (openBlock(), createElementBlock("div", mergeProps({
    key: 1,
    "class": _ctx.cx("subtitle")
  }, _ctx.ptm("subtitle")), [renderSlot(_ctx.$slots, "subtitle")], 16)) : createCommentVNode("", true)], 16)) : createCommentVNode("", true), createBaseVNode("div", mergeProps({
    "class": _ctx.cx("content")
  }, _ctx.ptm("content")), [renderSlot(_ctx.$slots, "content")], 16), _ctx.$slots.footer ? (openBlock(), createElementBlock("div", mergeProps({
    key: 1,
    "class": _ctx.cx("footer")
  }, _ctx.ptm("footer")), [renderSlot(_ctx.$slots, "footer")], 16)) : createCommentVNode("", true)], 16)], 16);
}
script2.render = render;

export {
  CardStyle,
  script2 as script
};
//# sourceMappingURL=chunk-VEJGBID5.js.map
