<?php

namespace modules\sales\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use modules\catalogs\Models\Category;
use modules\catalogs\Models\ProductCategory;
use modules\catalogs\Models\Products;
use modules\crm\Models\BusinessContact;
use modules\location\Models\Location;

class purchaseDocDetail extends Model
{
    use HasFactory;

    protected $table = "purchases_documents_details";
    protected $fillable = [
        'document_id',
        'row_type',
        'product_id',
        'product',
        'qty',
        'unite_id',
        'unite',
        'price_ht',
        'discount_by',
        'discount_rate',
        'discount_price',
        'tva_rate',
        'tva_price',
        'price_ttc',
    ];

    public function product(){        
        return $this->belongsTo(Products::class, 'supplier_id');
    }

    public function productCategory()
    {
        return $this->hasMany(ProductCategory::class, 'product_id', 'product_id');
    }

    // Relation avec Category (via ProductCategory)
    public function category()
    {
        return $this->hasManyThrough(
            Category::class,
            ProductCategory::class,
            'product_id', // Foreign key on ProductCategory
            'id',         // Foreign key on Category
            'product_id', // Local key on AccountingDocumentStatusDetail
            'category_id' // Local key on ProductCategory
        )->distinct();
    }

}