import "@bhplugin/vue3-datatable/dist/style.css";

import './bootstrap';
import 'flowbite';

import 'bootstrap-icons/font/bootstrap-icons.css';
import '../css/app.css';
import '../sass/custom.scss';

import PrimeVue from 'primevue/config';
import Aura from '@primeuix/themes/aura';
import { createApp } from "vue";
import { ZiggyVue } from '../../vendor/tightenco/ziggy/dist';



const app = createApp({});

app.use(ZiggyVue)
    .use(PrimeVue, {
        ripple: true,
        theme: {
            preset: Aura
        }
    });

const appContainer = document.querySelector('.app-container');
if(appContainer){
    const appId = appContainer.getAttribute('app');
    const components = {
        'list-permission': () => import('./Pages/Settings/Permissions/Index.vue'),
        'create-permission': () => import('./Pages/Settings/Permissions/Create.vue'),
        'edit-permission': () => import('./Pages/Settings/Permissions/Update.vue'),

        'list-user': () => import('./Pages/Settings/Users/Index.vue'),
        'create-user': () => import('./Pages/Settings/Users/Create.vue'),
        'edit-user': () => import('./Pages/Settings/Users/Update.vue'),
        
        'company': () => import('./Pages/Settings/Company.vue'),
    }

    if (components[appId]) {
        components[appId]().then(({ default: component }) => {
            app.component(appId.replace(/-/g, ''), component).mount(`#setting`);
        });
    } else {
        app.mount("#app");
    }
}else {
    app.mount("#app");
}
