import axios from 'axios';
window.axios = axios;

window.axios.defaults.headers.common['X-Requested-With'] = 'XMLHttpRequest';

import Swal from "sweetalert2";
window.Swal = Swal;
const Toast = Swal.mixin({
    toast: true,
    position: 'top-end',
    showConfirmButton: false,
    timer: 3000,
    timerProgressBar: false,
    didOpen: (toast) => {
        toast.addEventListener('mouseenter', Swal.stopTimer)
        toast.addEventListener('mouseleave', Swal.resumeTimer)
    }
});
window.Toast = Toast;

const swalWithBootstrapButtons = Swal.mixin({
    customClass: {
        confirmButton: 'px-4 py-2 bg-blue-600 text-white rounded-sm hover:bg-blue-700 font-bold uppercase mx-1',
        cancelButton: 'px-4 py-2 bg-red-600 text-white rounded hover:bg-red-700 font-bold uppercase mx-1'
    },
    buttonsStyling: false
});
const alertMessage = (title, message, status, confim, cancel) => {
    swalWithBootstrapButtons.fire({
        title: title,
        html: message,
        icon: status,
        showCancelButton: cancel.status,
        cancelButtonText: cancel.text,
        confirmButtonText: confim.text,
        reverseButtons: true
    }).then(function (e) {
        e.dismiss;
    }, function (dismiss) {
        return false;
    });
}
window.alertMessage = alertMessage;

const characters ='0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz@_-~#{[|]}';
const generateString = (length) => {
    let result = '';
    const charactersLength = characters.length;
    for ( let i = 0; i < length; i++ ) {
        result += characters.charAt(Math.floor(Math.random() * charactersLength));
    }
    return result;
}
window.generateString = generateString;

const swalButtons = Swal.mixin({
    customClass: {
        cancelButton: `px-4 rounded-sm uppercase py-3 ms-2 bg-red-600 text-sm font-semibold text-white shadow-sm hover:bg-red-500 focus-visible:outline focus-visible:outline-2 focus-visible:outline-offset-2 focus-visible:outline-red-600`,
        confirmButton: `px-4 rounded-sm uppercase py-3 bg-blue-600 text-sm font-semibold text-white shadow-sm hover:bg-blue-500 focus-visible:outline focus-visible:outline-2 focus-visible:outline-offset-2 focus-visible:outline-blue-600`,
    },
    buttonsStyling: false
});
window.swalButtons = swalButtons;