<html lang="fr">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
        <title>{{ $document['label'] }}</title>
        <link rel="icon" type="image/png" href="{{ public_path('images/default/favicon.ico') }}">
        <link rel="stylesheet" href="{{ public_path("css/doc.css") }}" media="all" />

        <style>
            @page {
                margin: 25px 20px;
                box-sizing: border-box;
            }

            *{
                font-family: sans-serif!important;
                color: #292524;
            }

            .page {
                page-break-after: always;
                position: relative;
                margin-bottom: 60px; 
            }

            .docTitle{
                display: inline-block; 
                vertical-align: middle; 
                margin: 0 0 0 10px; 
                font-size: 26px; 
                font-weight: bold;
                text-transform: uppercase;
            }

            .editor h3{
                margin-top: -10px;
                font-size: 24px;
            }

            .header{                
                margin-top: -25px; 
                margin-left: -20px; 
                margin-right: -20px; 
                padding-left: 10px; 
                padding-right: 10px; 
                padding-top: 25px;
            }

            .infoDocLeft{
                width: 50%; 
                vertical-align: top; 
                text-align: right; 
                padding: 8px;
            }

            .infoDocRight{
                width: 50%; 
                vertical-align: top; 
                text-align: left; 
                padding: 8px;
            }

            .tdFooter{
                border: 1px solid #9ca3af; 
                padding: 12px 5px;
                vertical-align: middle;
                font-size: 13px;
            }

            table {
                border-collapse: separate;
                border-spacing: 0;
            }

            .content{
                width: 100%;                
                margin-top: 20px;
            }

            .comment{                
                font-size: 13px!important;
            }
            .comment p{
                font-size: 13px!important;
            }
        </style>
    </head>

    <body>
        <div class="page">
            @include("documents.partials.invoice", [
                'detail' => $detail['customer']
            ])
        </div>
        
        @if($document['type'] == 'invoice' && $detail['customer']['document_for'] == 'customer')
            @include("documents.partials.invoice", [
                'detail' => $detail['site']
            ])
        @endif
    </body>
</html>