@php
    $bg = [
        'invoice' => '#06b6d4',  // Bleu cyan pour la facture
        'quote' => '#a8a29e',    // Gris doux pour le devis
        'credit' => '#fca5a5',   // Rouge pastel pour l'avoir
    ];
@endphp

<header class="header" style="background: {{$bg[$document['type']]}}">
    <table style="width: 100%;">
        <tr>
            <!-- Colonne de gauche (50%) -->
            <td style="width: 50%; vertical-align: top;">
                @if(!is_null($detail['document_logo']))
                    @php
                        $imagePath = public_path('images/sites/logo/'. $detail['document_logo']);
                        $imageData = base64_encode(file_get_contents($imagePath));
                        $imageSrc = 'data:image/png;base64,' . $imageData; // Ajustez le type MIME si nécessaire
                    @endphp
                    <div style="display: inline-block; vertical-align: middle;">
                        <img src="{{ $imageSrc }}" style="height: 100px;">                    
                    </div>
                @endif
            
                <h3 class="docTitle">{{ $document['label'] }}</h3>
            </td>

            <!-- Colonne de droite (50%) -->
            <td class="editor" style="width: 50%; vertical-align: top; text-align: justify; padding: 0 10px; font-size: 14px; line-height: 1; ">
                {!! nl2br($detail['document_header']) !!}
            </td>
        </tr>
    </table>
</header>

<section>
    <table style="width: 100%;">
        <tr>
            <!-- Colonne de gauche (50%) -->
            <td style="width: 50%; vertical-align: top;">
                <h3 style="font-weight: bold; font-size: 18px;;">CLIENT:</h3>
                <div style="line-height: .35; margin-left: 20px; margin-top: -10px">
                    <p style="font-size: 16px"><strong>{!! $detail['customer'] !!}</strong></p>
                    <p style="font-size: 14px">{!! nl2br($detail['customer_address']) !!}</p>
                </div>
            </td>

            <!-- Colonne de droite (50%) -->
            <td style="width: 50%; vertical-align: top; text-align: justify; padding: 0 10px; font-size: 15px; line-height: .5;">
                <table style="width: 100%; margin-top: 40px;">
                    <tr>
                        <!-- Sous-colonne 1 (50% de la colonne de droite) -->
                        <td class="infoDocLeft">
                            <strong>Date:</strong>
                        </td>
    
                        <!-- Sous-colonne 2 (50% de la colonne de droite) -->
                        <td class="infoDocRight">
                            <span>{{ date('d-m-Y', strtotime($detail['accounting_document_date'])) }}</span>
                        </td>
                    </tr>
                    <tr>
                        <!-- Sous-colonne 1 (50% de la colonne de droite) -->
                        <td class="infoDocLeft">
                            <strong>Numéro {{strtolower($document['label'])}}:</strong>
                        </td>
    
                        <!-- Sous-colonne 2 (50% de la colonne de droite) -->
                        <td class="infoDocRight">
                            <span>{{ $detail['reference'] }}</span>
                        </td>
                    </tr>
                    @if((float)$detail['rap'] != 0)
                    <tr>
                        <!-- Sous-colonne 1 (50% de la colonne de droite) -->
                        <td class="infoDocLeft">
                            <strong>Echéance:</strong>
                        </td>
    
                        <!-- Sous-colonne 2 (50% de la colonne de droite) -->
                        <td class="infoDocRight">
                            <span>{{ date('d-m-Y', strtotime($detail['accounting_document_release_date'])) }}</span>
                        </td>
                    </tr>
                    @endif
                </table>
            </td>
        </tr>
    </table>
</section>

<section class="content" style="border-top: 3px solid {{$bg[$document['type']]}};">
    <table style="width: 100%!important; margin-top: 10px;">
        <thead style="background: #cbd5e1">
            <tr>
                @foreach ($cols[$document['type']] as $k => $col)
                <th style="text-align: {{$col['align']}}; width: {{$col['width']}}; padding: 10px 5px">
                    <strong style="text-transform: uppercase; font-size: 13px;">{{$col['title']}}</strong>                                
                </th>
                @endforeach
            </tr>
        </thead>
        <tbody>
            @php
                $taxes = [];
            @endphp

            <tr>
                <td style="padding-bottom: 10px;" colspan="{{count($cols[$document['type']])}}"></td>
            </tr>

            {{-- @dd($detail) --}}
            @foreach ($detail['details'] as $i => $item)
                <tr>
                    
                    @if($item["row_type"] == 'product')
                        @php                    
                            $totalht = (double)$item['price_ht'] * (double)$item['qty'];
                            $taxrate = (float)$item['tva_rate'];
                            $taxeprice = (float)$totalht * ((float)$taxrate / 100);
                            $totalttc = $totalht + $taxeprice;

                            $taxes[$item['tva_rate']]['rate'][] = $taxrate;
                            $taxes[$item['tva_rate']]['ttc'][] = $totalttc;
                            $taxes[$item['tva_rate']]['price'][] = $taxeprice;
                            $taxes[$item['tva_rate']]['items'][] = $totalht;
                        @endphp

                        <td style="padding-left: 3px; padding-right: 3px; text-align: {{$cols[$document['type']][0]['align']}}; @if($item["row_type"] == 'product' && $i != 0) border-top: 2px solid #9ca3af; @endif">
                            <span style="font-size: 13px!important">
                                {!! implode(' - ', array_map(fn($cat) => "<span>{$cat['title']}</span>", $item['category'])) !!} - {{$item['product']}}
                            </span>                                  
                        </td>
                        <td style="padding-left: 3px; padding-right: 3px; text-align: {{$cols[$document['type']][1]['align']}}; @if($item["row_type"] == 'product' && $i != 0) border-top: 2px solid #9ca3af; @endif">
                            <span style="font-size: 13px!important">{{number_format($item['price_ht'], 2, ",", " ")."Ar"}}</span>
                        </td>
                        <td style="padding-left: 3px; padding-right: 3px; text-align: {{$cols[$document['type']][2]['align']}}; @if($item["row_type"] == 'product' && $i != 0) border-top: 2px solid #9ca3af; @endif">
                            <span style="font-size: 13px!important">{{$item['qty']}}</span>
                        </td>
                        <td style="padding-left: 3px; padding-right: 3px; text-align: {{$cols[$document['type']][3]['align']}}; @if($item["row_type"] == 'product' && $i != 0) border-top: 2px solid #9ca3af; @endif">
                            <span style="font-size: 13px!important">{{number_format($totalht, 2, ",", " ")."Ar"}}</span>
                        </td>
                        <td style="padding-left: 3px; padding-right: 3px; text-align: {{$cols[$document['type']][4]['align']}}; @if($item["row_type"] == 'product' && $i != 0) border-top: 2px solid #9ca3af; @endif">
                            <span style="font-size: 13px!important">{{$item['tva_rate']}}%</span>
                        </td>
                        <td style="padding-left: 3px; padding-right: 3px; text-align: {{$cols[$document['type']][5]['align']}}; @if($item["row_type"] == 'product' && $i != 0) border-top: 2px solid #9ca3af; @endif">
                            <span style="font-size: 13px!important">{{number_format($totalttc, 2, ",", " ")."Ar"}}</span>
                        </td>
                    @endif

                    @if($item['row_type'] == 'sous-total')
                        <td colspan="4" style="text-align: left!important; padding-left: 3px; padding-right: 3px;">
                            <span style="margin-top: 5px; margin-bottom: 5px; font-size: 14px; font-weight: bold;">{{$item['product']}}</span>
                        </td>
                        <td colspan="2" style="text-align: right!important; padding-left: 3px; padding-right: 3px;">
                            <span style="font-size: 14px; font-weight: bold;">{{number_format($item['price_ht'], 2, ",", " ")."Ar"}}</span>
                        </td>                    
                    @endif    

                    @if($item['row_type'] == 'title')
                        <td colspan="6" style="text-align: left!important; padding-left: 3px; padding-right: 3px;">
                            <h4 style="margin-top: 3px!important; margin-bottom: 3px!important; font-size: 13px;">{!! $item['product'] !!}</h4>
                        </td>
                    @endif

                    @if($item['row_type'] == 'texte')
                        <td colspan="6" style="text-align: left!important; padding-left: 3px; padding-right: 3px;">
                            <div class="comment">
                                {!! nl2br($item['product']) !!}
                            </div>
                        </td>
                    @endif

                    @if($item['row_type'] == 'container')
                        <td colspan="6" style="text-align: left!important; padding-left: 3px; padding-right: 3px;">
                            <strong style="font-size: 13px">N° Conteneur:</strong>
                            <span style="font-size: 13px!important">
                                {!! $item['product'] !!}
                            </span>
                        </td>
                    @endif

                    @if($item['row_type'] == 'power')
                        <td colspan="6" style="text-align: left!important; padding-left: 3px; padding-right: 3px;">
                            <strong style="font-size: 13px">Puissance:</strong>
                            <span style="font-size: 13px!important">
                                {!! $item['product'] !!}
                            </span>
                        </td>
                    @endif

                    @if($item['row_type'] == 'saut-page')
                        <td colspan="6" style="text-align: left!important; padding-left: 3px; padding-right: 3px;">
                            <div style="padding: 10px; width: 100%!important;"></div>
                        </td>
                    @endif
                </tr>                                  
            @endforeach
        </tbody>
    </table>
</section>

<section class="content" style="margin-top: 10px; border-top: 1px solid {{$bg[$document['type']]}};">
    <p style="font-size: 13px;">Arrêté la présente à la somme de {!! number_to_letter($detail['total_ttc']) !!} ariary</p>
    <table style="width: 100%; margin-top: -30px;">
        <tr>
            <!-- Colonne de gauche (50%) -->
            <td style="width: 50%; vertical-align: top;">
                
            </td>

            <!-- Colonne de droite (50%) -->
            <td style="width: 50%; vertical-align: top; padding: 0 10px; font-size: 15px; line-height: .5;">
                <table style="width: 100%; margin-top: 40px;">
                    <tr>
                        <!-- Sous-colonne 1 (50% de la colonne de droite) -->
                        <td class="infoDocLeft tdFooter" style="border-bottom: 0; text-align: right;">
                            <strong>Montant total HT</strong>
                        </td>
    
                        <!-- Sous-colonne 2 (50% de la colonne de droite) -->
                        <td class="infoDocRight tdFooter" style="border-left: 0; border-bottom: 0; text-align: right;">
                            <span>{{ number_format($detail['total_ht'], 2, ",", ' ') }}Ar</span>
                        </td>
                    </tr>

                    @if(isset($detail['document_for']) && $detail['document_for'] == 'site')
                    <tr>
                        <!-- Sous-colonne 1 (50% de la colonne de droite) -->
                        <td class="infoDocLeft tdFooter" style="border-bottom: 0; text-align: right;">
                            <strong>Frais livraison</strong>
                        </td>
    
                        <!-- Sous-colonne 2 (50% de la colonne de droite) -->
                        <td class="infoDocRight tdFooter" style="border-left: 0; border-bottom: 0; text-align: right;">
                            <span>{{ number_format($detail['delivery_price'], 2, ",", ' ') }}Ar</span>
                        </td>
                    </tr>
                    @endif

                    <tr>
                        <!-- Sous-colonne 1 (50% de la colonne de droite) -->
                        <td class="infoDocLeft tdFooter" style="border-bottom: 0; text-align: right;">
                            <strong>Remise</strong>
                        </td>                
                        <!-- Sous-colonne 2 (50% de la colonne de droite) -->
                        <td class="infoDocRight tdFooter" style="border-left: 0; border-bottom: 0; text-align: right;">
                            <span>{{ number_format($detail['discount_price'], 2, ",", ' ') }}Ar</span>
                        </td>
                    </tr>
                    <tr>
                        <!-- Sous-colonne 1 (50% de la colonne de droite) -->
                        <td class="infoDocLeft tdFooter" style="border-bottom: 0; text-align: right;">
                            <strong>TVA</strong> *
                        </td>                
                        <!-- Sous-colonne 2 (50% de la colonne de droite) -->
                        <td class="infoDocRight tdFooter" style="border-left: 0; border-bottom: 0; text-align: right;">
                            <span>{{ number_format($detail['tva_price'], 2, ",", ' ') }}Ar</span>
                        </td>
                    </tr>
                    <tr>
                        <!-- Sous-colonne 1 (50% de la colonne de droite) -->
                        <td class="infoDocLeft tdFooter" style="text-align: right;">
                            <strong>Montant total TTC</strong>
                        </td>                
                        <!-- Sous-colonne 2 (50% de la colonne de droite) -->
                        <td class="infoDocRight tdFooter" style="border-left: 0; text-align: right;">
                            <span>{{ number_format($detail['total_ttc'], 2, ",", ' ') }}Ar</span>
                        </td>
                    </tr>

                    @if($document['type'] != 'quote' && (float)$detail['rap'] != 0)
                    <tr>
                        <!-- Sous-colonne 1 (50% de la colonne de droite) -->
                        <td class="infoDocLeft tdFooter" style="text-align: right; border-bottom: 0;">
                            <strong>Acompte</strong>
                        </td>                
                        <!-- Sous-colonne 2 (50% de la colonne de droite) -->
                        <td class="infoDocRight tdFooter" style="border-left: 0; border-bottom: 0; text-align: right;">
                            <span>{{ number_format($detail['payment_total'], 2, ",", ' ') }}Ar</span>
                        </td>
                    </tr>
                    <tr>
                        <!-- Sous-colonne 1 (50% de la colonne de droite) -->
                        <td class="infoDocLeft tdFooter" style="text-align: right;">
                            <strong>Reste à payer</strong>
                        </td>                
                        <!-- Sous-colonne 2 (50% de la colonne de droite) -->
                        <td class="infoDocRight tdFooter" style="border-left: 0; text-align: right;">
                            <strong style="color: #b91c1c">{{ number_format(((float)$detail['rap'] * -1), 2, ",", ' ') }}Ar</strong>
                        </td>
                    </tr>
                    @endif
                </table>
            </td>
        </tr>
    </table>
</section>

<section class="content" style="margin-top: 10px; border-top: 0">                           
    <table style="width: 100%; margin-top: -30px;">
        <tr>
            <!-- Colonne de gauche (50%) -->
            <td style="width: 50%; vertical-align: top;">
                
                @if(count($detail['payments']) > 0)
                <h4 style="font-size: 14px; color: #292524; margin-bottom: 0!important; margin-top: 40px;">Paiements éffectués</h4>     
                <table style="width: 100%; margin-top: 10px; border-collapse: collapse; border: 1px solid #9ca3af;">
                    <thead>
                        <tr style="background-color: #f2f2f2; border: 1px solid #9ca3af;">
                            <th style="color: #292524; text-align: left; font-size: 13px; padding: 8px; border: 1px solid #9ca3af;">Date</th>
                            <th style="color: #292524; text-align: center; font-size: 13px; padding: 8px; border: 1px solid #9ca3af;">Type de règlement</th>
                            <th style="color: #292524; text-align: right; font-size: 13px; padding: 8px; border: 1px solid #9ca3af;">Montant</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach ($detail['payments'] as $item)
                            <tr style="border: 1px solid #9ca3af;">
                                <td style="text-align: left; font-size: 13px; padding: 8px; border: 1px solid #9ca3af;">
                                    {{ date('d-m-Y', strtotime($item['created_at'])) }}
                                </td>
                                <td style="text-align: center; font-size: 13px; padding: 8px; border: 1px solid #9ca3af;">
                                    {{ $item['payment_method'] }}
                                </td>
                                <td style="text-align: right; font-size: 13px; padding: 8px; border: 1px solid #9ca3af;">
                                    {{ number_format($item['amount'], 2, ",", " ") }} Ar
                                </td>
                            </tr>
                        @endforeach
                    </tbody>
                </table>                            
                @endif
            </td>
            <td style="width: 5%; vertical-align: top;"></td>
            <!-- Colonne de droite (50%) -->
            <td style="width: 45%; vertical-align: top;">
                <h4 style="font-size: 14px; color: #292524; margin-bottom: 0!important; margin-top: 40px;">* Détail taxe</h4>
                <table style="width: 100%; margin-top: 10px; border-collapse: collapse; border: 1px solid #9ca3af;">
                    <thead>
                        <tr style="background-color: #f2f2f2; border: 1px solid #9ca3af;">
                            <th style="color: #292524; text-align: center; font-size: 13px; padding: 8px; border: 1px solid #9ca3af;">Taux</th>
                            <th style="color: #292524; text-align: right; font-size: 13px; padding: 8px; border: 1px solid #9ca3af;">Base HT</th>
                            <th style="color: #292524; text-align: right; font-size: 13px; padding: 8px; border: 1px solid #9ca3af;">Montant TVA</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach($taxes as $k => $item)
                            <tr style="border: 1px solid #9ca3af;">
                                <td style="text-align: center; font-size: 13px; padding: 8px; border: 1px solid #9ca3af;">
                                    {{ number_format($taxes[$k]['rate'][0], 2, ",", " ") }}%
                                </td>
                                <td style="text-align: right; font-size: 13px; padding: 8px; border: 1px solid #9ca3af;">
                                    {{ number_format(array_sum($taxes[$k]['items']), 2, ",", " ") }}Ar
                                </td>
                                <td style="text-align: right; font-size: 13px; padding: 8px; border: 1px solid #9ca3af;">
                                    {{ number_format(array_sum($taxes[$k]['price']), 2, ",", " ") }}Ar
                                </td>
                            </tr>
                        @endforeach
                    </tbody>
                </table> 
            </td>
        </tr>
    </table>
</section>

<section class="">
    <table width="100%" style="margin-top: 20px; border-top: 1px solid {{$bg[$document['type']]}};">
        <tr>
            <td width="50%" style="text-align: left; padding: 20px;">
                <p style="font-size: 14px; font-weight: bold; text-decoration: underline;">Responsable</p>                            
            </td>
            <td width="50%" style="text-align: right; padding: 20px;">
                <p style="font-size: 14px; font-weight: bold; text-decoration: underline;">Client</p>                            
            </td>
        </tr>
    </table>
</section>