<?php

use App\Http\Controllers\CategoryController;
use App\Http\Controllers\ProductController;
use Illuminate\Support\Facades\Route;

Route::prefix('catalog')->as('catalog.')->group(function(){
    Route::prefix('category')->as('category.')->group(function(){
        Route::get('/', [CategoryController::class, 'index'])->name('index');
        Route::get('/create', [CategoryController::class, 'create'])->name('create');
        Route::get('/edit/{slug}', [CategoryController::class, 'edit'])->name('edit');
        Route::get('/get/categories', [CategoryController::class, 'categories'])->name('categories');

        Route::post('/store', [CategoryController::class, 'store'])->name('store');
        Route::post('/update', [CategoryController::class, 'update'])->name('update');
        Route::post('/status', [CategoryController::class, 'status'])->name('status');
        Route::post('/reorder', [CategoryController::class, 'reorder'])->name('reorder');

        Route::delete('/delete/{id}', [CategoryController::class, 'destroy'])->name('delete');
    });

    Route::prefix('product')->as('product.')->group(function(){
        Route::get('/', [ProductController::class, 'index'])->name('index');
        Route::get('/edit/{slug}', [ProductController::class, 'edit'])->name('edit');
        Route::get('/get/products', [ProductController::class, 'products'])->name('products');
        
        Route::post('/create', [ProductController::class, 'create'])->name('create');

        Route::as('update.')->prefix('update')->controller(ProductController::class)->group(function(){
            Route::post('/info', 'update_info')->name('info');
            Route::post('/price', 'update_price')->name('price');
        });
        
    });
});