<?php

use App\Http\Controllers\Admin\UserController;
use Illuminate\Support\Facades\Route;

Route::prefix("users")->as("users.")->group(function(){
    Route::get("/", [UserController::class, "index"])->name('index');
    Route::get("create", [UserController::class, "create"])->name('create');
    Route::get("edit/{id}", [UserController::class, "edit"])->name('edit');

    

    Route::post("store", [UserController::class, "store"])->name("store");
    Route::post("update", [UserController::class, "update"])->name("update");
    Route::post("status", [UserController::class, "status"])->name("status");
    Route::delete("delete/{id}", [UserController::class, "destroy"])->name("destroy");

    Route::prefix("ajax")->as("ajax.")->group(function(){
        Route::get('/get/users', [UserController::class, "get_users"])->name("get.users");
    });
});