<?php

use App\Http\Controllers\PermissionController;
use App\Http\Controllers\CompanyController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Artisan;

Route::get('/clear-cache', function () {
    Artisan::call("key:generate");

    Artisan::call('cache:clear');
    Artisan::call('config:clear');
    Artisan::call('route:clear');

    dd("success");
});

Route::as("app.")->group(function(){
    require __DIR__.'/auth.php';

    Route::middleware(['web', 'auth'])->group(function(){
        Route::as("setting.permission.")->prefix("settings/general/permissions")->group(function () {
            Route::get('/', [PermissionController::class, "index"])->name("index");
            Route::get('/data', [PermissionController::class, "data"])->name("data");
    
            Route::match(['get', 'post'], "/create", [PermissionController::class, "create"])->name('create');
            Route::match(['get', 'post'], "/edit/{id}", [PermissionController::class, "edit"])->name('edit');
            Route::post('/status', [PermissionController::class, "status"])->name("status");
            Route::delete('/delete/{id}/kl2502kql', [PermissionController::class, "destroy"])->name("destroy");
        });
    
        Route::prefix('settings/company')->as('setting.company.')->group(function () {
            Route::get('/', [CompanyController::class, 'index'])->name('index');
            Route::post('upload/logo', [CompanyController::class, 'upload_logo'])->name('upload_logo');
            Route::post('store/info', [CompanyController::class, 'store_info'])->name('store.info');
            Route::post('store/coordonnee', [CompanyController::class, 'store_coordonnee'])->name('store.coordonnee');
        });
    
    
        #users
        Route::prefix("settings/user")->as("setting.user.")->group(function(){
            Route::get("/", [UserController::class, "index"])->name('index');
            Route::get("create", [UserController::class, "create"])->name('create');
            Route::get("edit/{id}", [UserController::class, "edit"])->name('edit');        
    
            Route::post("store", [UserController::class, "store"])->name("store");
            Route::post("update", [UserController::class, "update"])->name("update");
            Route::post("status", [UserController::class, "status"])->name("status");
            Route::delete("delete/{id}", [UserController::class, "destroy"])->name("destroy");
    
            Route::prefix("ajax")->as("ajax.")->group(function(){
                Route::get('/get/users', [UserController::class, "get_users"])->name("get.users");
            });
        });
        #users
    });
});