<?php

namespace modules\sales\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use modules\crm\Models\BusinessContact;
use modules\location\Models\Location;

class Cart extends Model
{
    use HasFactory;

    protected $table = "carts";
    protected $fillable = [
        'location_id',
        'caisse_open_id',
        'location',
        'customer_id',
        'customer',
        'status',
        'total_price_ht',
        'total_price_ttc',
        'token',
        'user_id',
        'user',
    ];

    public function location() {
        return $this->belongsTo(Location::class, 'location_id');
    }
    
    public function customer() {
        return $this->belongsTo(BusinessContact::class, 'customer_id');
    }

    public function details() {
        return $this->hasMany(CartDetail::class, 'cart_id');
    }
}