<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('accounting_documents_status', function (Blueprint $table) {
            $table->id();
            $table->enum('type', ['invoice', 'order', 'credit', 'return']);
            $table->string('title');
            $table->text('description')->nullable();
            $table->string('background')->default('#fff');
            $table->string('color')->default('#000');
            $table->string('icon')->nullable();
            $table->enum('status', ['inactive', 'active'])->default('inactive');
            $table->boolean('is_default')->default(false);
            $table->boolean('use_default')->default(false);
            $table->enum('apply', ['customer', 'admin', 'both'])->nullable();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('accounting_documents_status');
    }
};
