export const documentTypes = {
    invoice: { 
        title: 'Facture',
        linkto: {
            value: false,
            data: [
                { value: 'none', title: 'Aucun' },
                { value: 'order', title: 'Bon de commande' },
                { value: 'delivery', title: 'Bon de livraison' },
                { value: 'return', title: 'Bon de retour' },
                { value: 'quote', title: 'Devis' },
            ]
        },
        payment: true,
        form: {
            release_date: {
                value: true,
                label: 'Date échéance'
            },
        },
        menus: {
            selected: "details",
            data: {
                details: {
                    text: "Détails",
                    not: [],
                    route: (slug, type) => route('app.sales.documents.edit', {slug, type}),
                },
                payment: {
                    text: `Paiements`, 
                    not: [],               
                    route: (slug, type) => route('app.sales.documents.edit', {slug, tab: 'paiements', type}),
                },
                /*story: {
                    text: "Historiques",  
                    not: [],              
                    route: (slug, type) => route('app.sales.documents.edit', {slug, tab: 'historiques', type}),
                },
                footer: {
                     text: "Pied de page",
                     route: (slug, type) => route('app.sales.documents.edit', {slug, tab: 'footer', type}),
                }*/
            },
        }
    },
    credit: { 
        title: 'Avoir',
        linkto: {
            value: false,
            data: [
                { value: 'none', title: 'Aucun' },
                { value: 'invoice', title: 'Facture' },
            ]
        },
        payment: true,
        form: {
            release_date: {
                value: false,
                label: 'Date échéance'
            },
        },
        menus: {
            selected: "details",
            data: {
                details: {
                    text: "Détails",
                    not: [],
                    route: (slug, type) => route('app.sales.documents.edit', {slug, type}),
                },
                story: {
                    text: "Historiques",  
                    not: [],              
                    route: (slug, type) => route('app.sales.documents.edit', {slug, tab: 'historiques', type}),
                },
                /*footer: {
                     text: "Pied de page",
                     route: (slug, type) => route('app.sales.documents.edit', {slug, tab: 'footer', type}),
                }*/
            },
        }
    },
    order: { 
        title: 'Bon de commande',
        linkto: false,
    },
    delivery: { 
        title: 'Bon de livraison',
        linkto: false,
    },
    return: { 
        title: 'Bon de retour',
        linkto: false,
    },
    quote: {
        title: 'Devis',
        linkto: {
            value: false,
            data: [
                { value: 'none', title: 'Aucun' },
                { value: 'order', title: 'Bon de commande' },                    
            ]
        },
        payment: false,
        form: {
            release_date: {
                value: true,
                label: 'Date expiration'
            },
        },
        menus: {
            selected: "details",
            data: {
                details: {
                    text: "Détails",
                    not: [],
                    route: (slug, type) => route('app.sales.documents.edit', {slug, type}),
                },
                /*story: {
                    text: "Historiques",
                    not: [],              
                    route: (slug, type) => route('app.sales.documents.edit', {slug, tab: 'historiques', type}),
                },
                footer: {
                     text: "Pied de page",
                     route: (slug, type) => route('app.sales.documents.edit', {slug, tab: 'footer', type}),
                }*/
            },
        }
    },
}
