<?php

namespace modules\stocks\Models;

use Illuminate\Database\Eloquent\Model;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use modules\location\Models\Location;
use modules\Stocks\Notifications\StockTransferNotification;

class StockTransfert extends Model
{
    use HasFactory;

    protected $table = "stocks_transfert";
    protected $fillable = [
        'document_id',
        'document',
        'source_location_id',
        'destination_location_id',
        'source_location',
        'destination_location',
        'slug',
        'requested_at',
        'expected_transfer_date',
        'notes',
        'status',
        'user_id',
        'username',
        'approved_at',
        'approved_by',
        'approved_username',
        'delivery_price'
    ];

    public function details()
    {
        return $this->hasMany(StockTransfertDetail::class, 'stock_transfer_id');
    }

    public function source()
    {
        return $this->belongsTo(Location::class, 'source_location_id');
    }

    public function destination()
    {
        return $this->belongsTo(Location::class, 'destination_location_id');
    }
}