<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('stocks_transfert_details', function (Blueprint $table) {
            $table->id();
            
            $table->unsignedBigInteger('stock_transfer_id'); // Référence à la demande de transfert
            $table->unsignedBigInteger('product_id'); // Référence au produit
            $table->string('product_name'); // Nom du produit
            $table->unsignedInteger('quantity'); // Quantité demandée pour le transfert
            $table->unsignedInteger('transferred_quantity')->nullable(); // Quantité réellement transférée
            $table->text('notes')->nullable(); // Notes ou commentaires spécifiques au produit
            $table->timestamps(); // Colonnes created_at et updated_at

            // Clés étrangères
            $table->foreign('stock_transfer_request_id')->references('id')->on('stocks_transfert')->onDelete('cascade');
            $table->foreign('product_id')->references('id')->on('products')->onDelete('cascade');
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('stocks_transfert_details');
    }
};
