<?php

use Illuminate\Support\Facades\Route;
use modules\stocks\Http\Controllers\approController;
use modules\stocks\Http\Controllers\inventoryController;
use modules\stocks\Http\Controllers\stocksController;

Route::prefix('/stocks')
    ->as("app.stock.")
    ->middleware(['web', 'auth'])
    ->group(function(){        
        Route::prefix('appro')->as('appro.')->group(function(){
            Route::get('/', [approController::class, 'index'])->name('index');
            Route::get('/create', [approController::class, 'create'])->name('create');
            Route::get('/detail/{slug}', [approController::class, 'detail'])->name('detail');
            Route::get('/appros', [approController::class, 'appros'])->name('appros');             

            Route::post('/strore', [approController::class, 'store'])->name('store');

            Route::put('/destroy', [approController::class, 'destroy'])->name('destroy');
        });

        Route::prefix('inventory')->as('inventory.')->group(function(){
            Route::get('/', [inventoryController::class, 'index'])->name('index');
            Route::get('/create', [inventoryController::class, 'create'])->name('create');
            Route::get('/show/{slug}', [inventoryController::class, 'detail'])->name('detail');
            Route::get('/print', [inventoryController::class, 'print'])->name('print');
            Route::get('/getinventory', [inventoryController::class, 'getinventory'])->name('get');          

            Route::get('/print/document/{slug}', [inventoryController::class, 'document'])->name('document');
            Route::get('/print/matrice', [inventoryController::class, 'matrice'])->name('matrice');
            
            Route::post('/store', [inventoryController::class, 'store'])->name('store');            
            Route::post('/validate', [inventoryController::class, 'inventory_validate'])->name('validate');            
        });        
        
        Route::prefix('stock-transfert')->as('transfert.')->group(function(){
            Route::get('/', [stocksController::class, 'index'])->name('index');
            Route::get('/detail/{slug}', [stocksController::class, 'detail'])->name('detail');

            Route::get('/transferts', [stocksController::class, 'transferts'])->name('transferts');

            Route::post('/strore', [stocksController::class, 'storeTransfert'])->name('store');
            Route::post('/status', [stocksController::class, 'statusTransefrt'])->name('status');
        });
    
});