/**
 * @license Copyright (c) 2003-2025, CKSource Holding sp. z o.o. All rights reserved.
 * For licensing, see LICENSE.md or https://ckeditor.com/legal/ckeditor-licensing-options
 */

( e => {
const { [ 'pl' ]: { dictionary, getPluralForm } } = {"pl":{"dictionary":{"Special characters":"Znaki specjalne","Category":"Kategorie","All":"Wszystko","Arrows":"Strzałki","Currency":"Waluta","Latin":"Łaciński","Mathematical":"Matematyczne","Text":"Tekst","leftwards simple arrow":"prosta strzałka w lewo","rightwards simple arrow":"prosta strzałka w prawo","upwards simple arrow":"prosta strzałka w górę","downwards simple arrow":"prosta strzałka w dół","leftwards double arrow":"podwójna strzałka w lewo","rightwards double arrow":"podwójna strzałka w prawo","upwards double arrow":"podwójna strzałka w górę","downwards double arrow":"podwójna strzałka w dół","leftwards dashed arrow":"przerywana strzałka w lewo","rightwards dashed arrow":"przerywana strzałka w prawo","upwards dashed arrow":"przerywana strzałka w górę","downwards dashed arrow":"przerywana strzałka w dół","leftwards arrow to bar":"strzałka w lewo do belki","rightwards arrow to bar":"strzałka w prawo do belki","upwards arrow to bar":"strzałka w górę do belki","downwards arrow to bar":"strzałka w dół do belki","up down arrow with base":"strzałka w górę i w dół z podstawą","back with leftwards arrow above":"do tyłu ze strzałką w lewo powyżej","end with leftwards arrow above":"koniec ze strzałką w lewo powyżej","on with exclamation mark with left right arrow above":"na z wykrzyknikiem i strzałką w lewo i prawo powyżej","soon with rightwards arrow above":"wkrótce ze strzałką w prawo powyżej","top with upwards arrow above":"do góry ze strzałką w górę powyżej","Dollar sign":"Znak dolara","Euro sign":"Znak euro","Yen sign":"Znak jena","Pound sign":"Znak funta","Cent sign":"Znak centa","Euro-currency sign":"Znak euro","Colon sign":"Znak colona","Cruzeiro sign":"Znak cruzeiro","French franc sign":"Znak franka francuskiego","Lira sign":"Znak liry","Currency sign":"Znak waluty","Bitcoin sign":"Znak bitcoina","Mill sign":"Symbol mila","Naira sign":"Znak nairy","Peseta sign":"Znak pesety","Rupee sign":"Znak rupii","Won sign":"Znak wona","New sheqel sign":"Znak nowego szekla","Dong sign":"Znak donga","Kip sign":"Znak kipa","Tugrik sign":"Znak tugrika","Drachma sign":"Znak drachmy","German penny sign":"Znak feniga","Peso sign":"Znak peso","Guarani sign":"Znak guarani","Austral sign":"Znak australa","Hryvnia sign":"Znak hrywny","Cedi sign":"Znak cedi","Livre tournois sign":"Symbol liwra turońskiego","Spesmilo sign":"Symbol spesmilo","Tenge sign":"Znak tenge","Indian rupee sign":"Znak rupii indyjskiej","Turkish lira sign":"Znak liry tureckiej","Nordic mark sign":"Znak marki nordyckiej","Manat sign":"Znak manata","Ruble sign":"Znak rubla","Latin capital letter a with macron":"Łacińska wielka litera a z makronem","Latin small letter a with macron":"Łacińska mała litera a z makronem","Latin capital letter a with breve":"Łacińska wielka litera a z łuczkiem","Latin small letter a with breve":"Łacińska mała litera a z łuczkiem","Latin capital letter a with ogonek":"Łacińska wielka litera a z ogonkiem","Latin small letter a with ogonek":"Łacińska mała litera a z ogonkiem","Latin capital letter c with acute":"Łacińska wielka litera c z kreską","Latin small letter c with acute":"Łacińska mała litera c z kreską","Latin capital letter c with circumflex":"Łacińska wielka litera c z daszkiem","Latin small letter c with circumflex":"Łacińska mała litera c z daszkiem","Latin capital letter c with dot above":"Łacińska wielka litera c z kropką powyżej","Latin small letter c with dot above":"Łacińska mała litera c z kropką powyżej","Latin capital letter c with caron":"Łacińska wielka litera c z ptaszkiem","Latin small letter c with caron":"Łacińska mała litera c z ptaszkiem","Latin capital letter d with caron":"Łacińska wielka litera d z ptaszkiem","Latin small letter d with caron":"Łacińska mała litera d z ptaszkiem","Latin capital letter d with stroke":"Łacińska wielka litera d z przekreśleniem","Latin small letter d with stroke":"Łacińska mała litera d z przekreśleniem","Latin capital letter e with macron":"Łacińska wielka litera e z makronem","Latin small letter e with macron":"Łacińska mała litera e z makronem","Latin capital letter e with breve":"Łacińska wielka litera e z łuczkiem","Latin small letter e with breve":"Łacińska mała litera e z łuczkiem","Latin capital letter e with dot above":"Łacińska wielka litera e z kropką powyżej","Latin small letter e with dot above":"Łacińska mała litera e z kropką powyżej","Latin capital letter e with ogonek":"Łacińska wielka litera e z ogonkiem","Latin small letter e with ogonek":"Łacińska mała litera e z ogonkiem","Latin capital letter e with caron":"Łacińska wielka litera e z ptaszkiem","Latin small letter e with caron":"Łacińska mała litera e z ptaszkiem","Latin capital letter g with circumflex":"Łacińska wielka litera g z daszkiem","Latin small letter g with circumflex":"Łacińska mała litera g z daszkiem","Latin capital letter g with breve":"Łacińska wielka litera g z łuczkiem","Latin small letter g with breve":"Łacińska mała litera g z łuczkiem","Latin capital letter g with dot above":"Łacińska wielka litera g z kropką powyżej","Latin small letter g with dot above":"Łacińska mała litera g z kropką powyżej","Latin capital letter g with cedilla":"Łacińska wielka litera g z haczykiem","Latin small letter g with cedilla":"Łacińska mała litera g z haczykiem","Latin capital letter h with circumflex":"Łacińska wielka litera h z daszkiem","Latin small letter h with circumflex":"Łacińska mała litera h z daszkiem","Latin capital letter h with stroke":"Łacińska wielka litera h z przekreśleniem","Latin small letter h with stroke":"Łacińska mała litera h z przekreśleniem","Latin capital letter i with tilde":" Łacińska wielka litera i z tyldą","Latin small letter i with tilde":"Łacińska mała litera i z tyldą","Latin capital letter i with macron":"Łacińska wielka litera i z makronem","Latin small letter i with macron":"Łacińska mała litera i z makronem","Latin capital letter i with breve":"Łacińska wielka litera i z łuczkiem","Latin small letter i with breve":"Łacińska mała litera i z łuczkiem","Latin capital letter i with ogonek":"Łacińska wielka litera i z ogonkiem","Latin small letter i with ogonek":"Łacińska mała litera i z ogonkiem","Latin capital letter i with dot above":"Łacińska wielka litera i z kropką powyżej","Latin small letter dotless i":"Łacińska mała litera i bez kropki","Latin capital ligature ij":"Łacińska wielka ligatura ij","Latin small ligature ij":"Łacińska mała ligatura ij","Latin capital letter j with circumflex":"Łacińska wielka litera j z daszkiem","Latin small letter j with circumflex":"Łacińska mała litera j z daszkiem","Latin capital letter k with cedilla":"Łacińska wielka litera k z haczykiem","Latin small letter k with cedilla":"Łacińska mała litera k z haczykiem","Latin small letter kra":"Łacińska mała litera kra","Latin capital letter l with acute":"Łacińska wielka litera l z kreską","Latin small letter l with acute":"Łacińska mała litera l z kreską","Latin capital letter l with cedilla":"Łacińska wielka litera l z haczykiem","Latin small letter l with cedilla":"Łacińska mała litera l z haczykiem","Latin capital letter l with caron":"Łacińska wielka litera l z ptaszkiem","Latin small letter l with caron":"Łacińska mała litera l z ptaszkiem","Latin capital letter l with middle dot":"Łacińska wielka litera l z kropką pośrodku","Latin small letter l with middle dot":"Łacińska mała litera l z kropką pośrodku","Latin capital letter l with stroke":"Łacińska wielka litera l z przekreśleniem","Latin small letter l with stroke":"Łacińska mała litera l z przekreśleniem","Latin capital letter n with acute":"Łacińska wielka litera n z kreską","Latin small letter n with acute":"Łacińska mała litera n z kreską","Latin capital letter n with cedilla":"Łacińska wielka litera n z haczykiem","Latin small letter n with cedilla":"Łacińska mała litera n z haczykiem","Latin capital letter n with caron":"Łacińska wielka litera n z ptaszkiem","Latin small letter n with caron":"Łacińska mała litera n z ptaszkiem","Latin small letter n preceded by apostrophe":"Łacińska mała litera n poprzedzona apostrofem","Latin capital letter eng":"Łacińska wielka litera eng","Latin small letter eng":"Łacińska mała litera eng","Latin capital letter o with macron":"Łacińska wielka litera o z makronem","Latin small letter o with macron":"Łacińska mała litera o z makronem","Latin capital letter o with breve":"Łacińska wielka litera o z łuczkiem","Latin small letter o with breve":"Łacińska mała litera o z łuczkiem","Latin capital letter o with double acute":"Łacińska wielka litera o z dwiema kreskami","Latin small letter o with double acute":"Łacińska mała litera o z dwiema kreskami","Latin capital ligature oe":"Łacińska wielka ligatura oe","Latin small ligature oe":"Łacińska mała ligatura oe","Latin capital letter r with acute":"Łacińska wielka litera r z kreską","Latin small letter r with acute":"Łacińska mała litera r z kreską","Latin capital letter r with cedilla":"Łacińska wielka litera r z haczykiem","Latin small letter r with cedilla":"Łacińska mała litera r z haczykiem","Latin capital letter r with caron":"Łacińska wielka litera r z ptaszkiem","Latin small letter r with caron":"Łacińska mała litera r z ptaszkiem","Latin capital letter s with acute":"Łacińska wielka litera s z kreską","Latin small letter s with acute":"Łacińska mała litera s z kreską","Latin capital letter s with circumflex":"Łacińska wielka litera s z daszkiem","Latin small letter s with circumflex":"Łacińska mała litera s z daszkiem","Latin capital letter s with cedilla":"Łacińska wielka litera s z haczykiem","Latin small letter s with cedilla":"Łacińska wielka litera s z haczykiem","Latin capital letter s with caron":"Łacińska wielka litera s z ptaszkiem","Latin small letter s with caron":"Łacińska mała litera s z ptaszkiem","Latin capital letter t with cedilla":"Łacińska wielka litera t z haczykiem","Latin small letter t with cedilla":"Łacińska mała litera t z haczykiem","Latin capital letter t with caron":"Łacińska wielka litera t z ptaszkiem","Latin small letter t with caron":"Łacińska mała litera t z ptaszkiem","Latin capital letter t with stroke":"Łacińska wielka litera t z przekreśleniem","Latin small letter t with stroke":"Łacińska mała litera t z przekreśleniem","Latin capital letter u with tilde":"Łacińska wielka litera u z tyldą","Latin small letter u with tilde":"Łacińska mała litera u z tyldą","Latin capital letter u with macron":"Łacińska wielka litera u z makronem","Latin small letter u with macron":"Łacińska mała litera u z makronem","Latin capital letter u with breve":"Łacińska wielka litera u z łuczkiem","Latin small letter u with breve":"Łacińska mała litera u z łuczkiem","Latin capital letter u with ring above":"Łacińska wielka litera u z kółkiem powyżej","Latin small letter u with ring above":"Łacińska mała litera u z kółkiem powyżej","Latin capital letter u with double acute":"Łacińska wielka litera u z dwiema kreskami","Latin small letter u with double acute":"Łacińska mała litera u z dwiema kreskami","Latin capital letter u with ogonek":"Łacińska wielka litera u z ogonkiem","Latin small letter u with ogonek":"Łacińska mała litera u z ogonkiem","Latin capital letter w with circumflex":"Łacińska wielka litera w z daszkiem","Latin small letter w with circumflex":"Łacińska mała litera w z daszkiem","Latin capital letter y with circumflex":"Łacińska wielka litera y z daszkiem","Latin small letter y with circumflex":"Łacińska mała litera y z daszkiem","Latin capital letter y with diaeresis":"Łacińska wielka litera y z dwiema kropkami","Latin capital letter z with acute":"Łacińska wielka litera z z kreską","Latin small letter z with acute":"Łacińska mała litera z z kreską","Latin capital letter z with dot above":"Łacińska wielka litera z z kropką powyżej","Latin small letter z with dot above":"Łacińska mała litera z z kropką powyżej","Latin capital letter z with caron":"Łacińska wielka litera z z ptaszkiem","Latin small letter z with caron":"Łacińska mała litera z z ptaszkiem","Latin small letter long s":"Łacińska litera długie s","Less-than sign":"Znak mniejszości","Greater-than sign":"Znak większości","Less-than or equal to":"Znak mniejsze niż lub równe","Greater-than or equal to":"Znak większe niż lub równe","En dash":"Półpauza","Em dash":"Pauza","Macron":"Makron","Overline":"Nadkreślenie","Degree sign":"Znak stopnia","Minus sign":"Znak minus","Plus-minus sign":"Znak plus-minus","Division sign":"Znak dzielenia","Fraction slash":"Kreska ułamkowa","Multiplication sign":"Znak mnożenia","Latin small letter f with hook":"Łacińska mała litera f z zawijasem","Integral":"Całka","N-ary summation":"Suma n-argumentowa","Infinity":"Nieskończoność","Square root":"Pierwiastek kwadratowy","Tilde operator":"Operator tylda","Approximately equal to":"W przybliżeniu równe","Almost equal to":"Prawie równe","Not equal to":"Różne","Identical to":"Identyczne","Element of":"Należy do","Not an element of":"Nie należy do","Contains as member":"Zawiera element","N-ary product":"Iloczyn n-argumentowy","Logical and":"Koniunkcja logiczna","Logical or":"Alternatywa logiczna","Not sign":"Znak negacji","Intersection":"Część wspólna","Union":"Suma zbiorów","Partial differential":"Pochodna cząstkowa","For all":"Kwantyfikator ogólny","There exists":"Kwantyfikator szczegółowy","Empty set":"Zbiór pusty","Nabla":"Operator nabla","Asterisk operator":"Operator asterysk","Proportional to":"Proporcjonalność","Angle":"Kąt","Vulgar fraction one quarter":"Ułamek zwykły jedna czwarta","Vulgar fraction one half":"Ułamek zwykły jedna druga","Vulgar fraction three quarters":"Ułamek zwykły trzy czwarte","Single left-pointing angle quotation mark":"Pojedynczy lewy cudzysłów kątowy","Single right-pointing angle quotation mark":"Pojedynczy prawy cudzysłów kątowy","Left-pointing double angle quotation mark":"Podwójny lewy cudzysłów kątowy","Right-pointing double angle quotation mark":"Podwójny prawy cudzysłów kątowy","Left single quotation mark":"Pojedynczy lewy cudzysłów","Right single quotation mark":"Pojedynczy prawy cudzysłów","Left double quotation mark":"Podwójny lewy cudzysłów","Right double quotation mark":"Podwójny prawy cudzysłów","Single low-9 quotation mark":"Pojedynczy dolny cudzysłów","Double low-9 quotation mark":"Podwójny dolny cudzysłów","Inverted exclamation mark":"Odwrócony wykrzyknik","Inverted question mark":"Odwrócony pytajnik","Two dot leader":"Dwie kropki wiodące","Horizontal ellipsis":"Wielokropek poziomy","Double dagger":"Podwójny sztylet","Per mille sign":"Znak promila","Per ten thousand sign":"Punkt bazowy","Double exclamation mark":"Podwójny wykrzyknik","Question exclamation mark":"Pytajnik z wykrzyknikiem","Exclamation question mark":"Wykrzyknik z pytajnikiem","Double question mark":"Podwójny pytajnik","Copyright sign":"Znak praw autorskich","Registered sign":"Zastrzeżony znak towarowy","Trade mark sign":"Symbol znaku towarowego","Section sign":"Znak sekcji","Paragraph sign":"Znak akapitu","Reversed paragraph sign":"Odwrócony znak akapitu"},getPluralForm(n){return (n == 1 ? 0 : n % 10 >= 2 && n % 10 <= 4 && (n % 100 < 10 || n % 100 >= 20) ? 1 : 2);}}};
e[ 'pl' ] ||= { dictionary: {}, getPluralForm: null };
e[ 'pl' ].dictionary = Object.assign( e[ 'pl' ].dictionary, dictionary );
e[ 'pl' ].getPluralForm = getPluralForm;
} )( window.CKEDITOR_TRANSLATIONS ||= {} );
